// Output generated from file: C:/Users/Allen/Documents/zips/Fragmentarium-Desktop_Qt_5_1_1_MinGW_32bit-Release/Fragmentarium-Desktop_Qt_5_1_1_MinGW_32bit-Release/clouds.png Files/clouds.frag
// Created: Mon Mar 2 08:51:03 2015
// Output generated from file: C:/Users/Allen/Documents/new-CR05/new-CR05/pythagore.frag
// Created: Sun Mar 1 22:42:20 2015
#info pythagore tree 3D
#define providesInit
#define USE_EIFFIE_SHADOW
#define USE_IQ_CLOUDS
#include "DE-kn2Clouds.frag"
#group pythagore
// Number of fractal iterations.
uniform int Iterations;  slider[0,5,20]
// Mandelbulb exponent (8 is standard)
uniform float Size; slider[0,1,5]
//
uniform float RotAngle; slider[0.00,0,180]

mat2 rot;
uniform float time;
void init() {
	float r=(RotAngle+10.*time)*PI/180.;
	float c=cos(r), s=sin(r);
	 rot = mat2(c,s,-s,c);
}

float DEbox(vec3 p, float a){
	p=abs(p);
	p=p-vec3(a);
	return max(p.x,max(p.y,p.z));
}
float DEpythagore(vec3 p){
	float is=1.;
	float d=DEbox(p,Size);
	vec3 tr=Size*vec3(3.,0.,1.);
	float BVR=8.*Size;
	for (int i=0; i<Iterations; i++){
#if 1
		float rh=dot(p,p)*is*is;
		float lh=d+BVR*is;
		if(rh>lh*lh) break;
#endif
#if 0
		if(dot(p,p)>BVR*BVR*4.){
			float d1=(length(p)-BVR)*is;
			//float t=clamp(d1/(BVR*(sqrt(2.)-1.)), 0.,1.);
			d=min(d,d1);//
			//d=smoothstep(d,d1,t);//
			break;
		}
#endif
		//if(dot(p,p)>100.) break;
		//rotate
		p.xy=rot*p.xy;//vec2(-1.,1.)*p.yx;
		//fold
		p.x=abs(p.x);
		//translate
		p-=tr;
		//rotate
		p.xz=sqrt(.5)*mat2(1.,1.,-1.,1.)*p.xz;
		//scale
		p*=sqrt(2.); is*=sqrt(.5);
		//translate back
		p+=tr;
		//trap
		d=min(d,DEbox(p,Size)*is);
	}
	return d;// min(d,(length(p)-8.*Size)*is);
}
float DE(vec3 p) {
	//return DEbox(p,1.);
	return DEpythagore(p);
}






#preset default
FOV = 0.4
Eye = -13.85,-7.658,6.757
Target = -5.08367,-2.718,4.726
FocalPlane = 1
Aperture = 0
InFocusAWidth = 0
ApertureNbrSides = 5
ApertureRot = 0
ApStarShaped = false
Gamma = 2
ToneMapping = 4
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 0.25
BloomPow = 2
BloomTaps = 4
Detail = -3
DetailAO = -0.5
FudgeFactor = 1
MaxRaySteps = 256
MaxDistance = 46
Dither = 0.5
NormalBackStep = 1
AO = 0,0,0,0.97531
AoCorrect = 0
Specular = 0.28235
SpecularExp = 9.091
SpecularMax = 7.547
CamLight = 1,1,1,0.84616
CamLightMin = 0.5303
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
ShadowBlur = 0
Reflection = 0
ReflectionsNumber = 0
SpotLight = 1,1,1,1
LightPos = 0,4.6068,8.427
LightSize = 0.80412
LightFallOff = 0
LightGlowRad = 0.6757
LightGlowExp = 1
HardShadow = 0.84615
ShadowSoft = 12.5806
BaseColor = 1,0.647059,0.411765
OrbitStrength = 0
X = 0.5,0.6,0.6,0.7
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.384314,0.501961,0.6
GradientBackground = 0.3
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,1
FloorHeight = -1
FloorColor = 0.231373,0.4,0.258824
HF_Fallof = 0.01
HF_Const = 0
HF_Intensity = 0
HF_Dir = 0.0097,0,1
HF_Offset = 0.3798
HF_Color = 1,1,1,0.4
CloudScale = 1.49224
CloudRoughness = 0.80952
CloudContrast = 3.4043
CloudColor = 0.686275,0.67451,0.698039
SunLightColor = 1,1,0.498039
Iterations = 8
Size = 1
RotAngle = 90
CloudFlatness = 0.73636
CloudTops = 1.746
CloudBase = -2.258
CloudDensity = 0.76271
Up = 0,0.0164,1
#endpreset

