// Output generated from file: D:/programs install/fraclal generators/Fragmentarium-anim/Examples/Tutorials/25 - Image Based Lighting.frag
// Created:  22.  01:27:13 2015
// An example of Image Based Lighting.
//
// NOTICE:
//  The Ditch-River Panorama HDR is authored by 'Blotchi' and copyrighted by http://www.hdrlabs.com/sibl/archive.html
//  It is licensed under a CC3.0 license: http://creativecommons.org/licenses/by-nc-sa/3.0/us/
//#include "IBL-Raytracer.frag"
#define KN_VOLUMETRIC
#define USE_EIFFIE_SHADOW
#include "DE-kn2.frag"
#include "QuilezLib.frag"
#group TestScene
uniform float TextureScale; slider[0,1,40]

// Just a simple test scene...
float DE(vec3 p)
{	
       p.xy=p.yx;
	float d = length(p+vec3(0.0,0.0,-0.25))-0.25;   //  sphere
	d= min(d, udRoundBox(p+vec3(1.6,-1.0,-0.1),vec3(0.2,2.5,3.5),0.05)); // rounded box
	d =min(d, sdCone(p+vec3(1.,1.,-0.5),vec2(0.95,0.45))); // cone
	d = min(d, sdTorus88(p+vec3(-1.4,1.,-0.6),vec2(0.5,0.1))); // torus
	return min(p.z,d);// distance estimate
}



#preset black-spots3
FOV = 0.58536
Eye = -0.429494,-0.332484,0.559112
Target = -4.13919,8.92168,-0.214661
Up = -0.0327384,0.0678702,0.997157
FocalPlane = 0.84333
Aperture = 0.08434
InFocusAWidth = 0.41509
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.62964
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0
SpecularExp = 0
SpecularMax = 52.83
CamLight = 1,1,1,1.53846
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
ShadowBlur = 0
Reflection = 0.30769
ReflectionsNumber = 2
SpotLight = 1,0.694118,0.439216,1.39705
LightPos = -1.2008,0.337,0.7418
LightSize = 0.12871
LightGlowRad = 0.1923
LightGlowExp = 1.26665
HardShadow = 0
BaseColor = 0.560784,0.560784,0.560784
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.0745098,0.0941176,0.133333
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.211765,0.388235,0.243137
HF_Fallof = 0.00001
HF_Const = 0
HF_Intensity = 0
HF_Dir = -0.01204,-0.01204,1
HF_Offset = -0.0862
HF_Color = 0.768627,0.980392,1,0.38462
TextureScale = 0
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset


#preset Default
FOV = 0.58536
Eye = -2.16805,-1.58807,0.9869
Target = 3.85964,5.7232,-2.20876
Up = 0.064906,0.0329476,0.997347
FocalPlane = 1.45921
Aperture = 0
InFocusAWidth = 0.9434
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 2.2
ToneMapping = 5
Exposure = 0.40245
Brightness = 1
Contrast = 1.4706
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -1.5
FudgeFactor = 1
MaxRaySteps = 260
MaxDistance = 63.83
Dither = 0.53608
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
CamLight = 1,1,1,1
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Reflection = 0.21519
ReflectionsNumber = 2 Locked
SpotLight = 1,0.913725,0.705882,10
LightPos = 6.7742,5.5844,5.8442
LightSize = 0.56436
LightFallOff = 0.29214
LightGlowRad = 1.4189
LightGlowExp = 1.26665
HardShadow = 0.89024 Locked
ShadowSoft = 8.8888
BaseColor = 0.745098,0.639216,0.568627
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.305882,0.392157,0.564706
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Fallof = 0.90361
HF_Const = 0
HF_Intensity = 0.1
HF_Dir = 0,0,1
HF_Offset = 0
HF_Color = 0.768627,0.980392,1,2.15094
TextureScale = 0
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset bloom1
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.604385
Aperture = 0
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = true
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,0.27692
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0.4
ReflectionsNumber = 5
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightGlowRad = 1.4189
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.0745098,0.0941176,0.133333
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.211765,0.388235,0.243137
HF_Fallof = 0.00001
HF_Intensity = 0
HF_Color = 0.768627,0.980392,1,0.38462
HF_Dir = -0.01204,-0.01204,1
HF_Offset = -0.0862
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset bloom2-reflNumb=5
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.604385
Aperture = 0.42708
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = true
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,0.27692
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0.4
ReflectionsNumber = 5
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightGlowRad = 1.4189
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.0745098,0.0941176,0.133333
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.211765,0.388235,0.243137
HF_Fallof = 0.00001
HF_Intensity = 0
HF_Color = 0.768627,0.980392,1,0.38462
HF_Dir = -0.01204,-0.01204,1
HF_Offset = -0.0862
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset bloom3-reflNumb=2
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.604385
Aperture = 0.42708
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = true
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,0.27692
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0.4
ReflectionsNumber = 2
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightGlowRad = 1.4189
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.0745098,0.0941176,0.133333
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.211765,0.388235,0.243137
HF_Fallof = 0.00001
HF_Intensity = 0
HF_Color = 0.768627,0.980392,1,0.38462
HF_Dir = -0.01204,-0.01204,1
HF_Offset = -0.0862
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset bloom4-FF<1
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.604385
Aperture = 0.42708
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = true
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 0.8481
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,0.27692
CamLightMin = 0
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0.4
ReflectionsNumber = 5
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightGlowRad = 1.4189
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.0745098,0.0941176,0.133333
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.211765,0.388235,0.243137
HF_Fallof = 0.00001
HF_Intensity = 0
HF_Color = 0.768627,0.980392,1,0.38462
HF_Dir = -0.01204,-0.01204,1
HF_Offset = -0.0862
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset


#preset black-spots
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
Up = 0.063455,0.0206507,0.997771
FocalPlane = 0.239458
Aperture = 0.4375
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
CamLight = 1,1,1,1.23076
CamLightMin = 0.44304
Glow = 1,1,1,0
GlowMax = 20
Reflection = 0.4
ReflectionsNumber = 5 Locked
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightFallOff = 0.29214
LightGlowRad = 1.4189
LightGlowExp = 1.26665
HardShadow = 0 Locked
ShadowSoft = 2
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.305882,0.392157,0.564706
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Fallof = 0.00001
HF_Const = 0
HF_Intensity = 0
HF_Dir = 0,0,1
HF_Offset = 0
HF_Color = 1,1,1,1
TextureScale = 0
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset hfog-smallMaxDist
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.239458
Aperture = 0
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,1.23076
CamLightMin = 0.44304
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0.4
ReflectionsNumber = 0
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightGlowRad = 1.4189
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.305882,0.392157,0.564706
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Fallof = 0.10526
HF_Intensity = 1.87014
HF_Color = 0.768627,0.980392,1,0.38462
HF__Dir = -0.01204,-0.01204,1
HF_Offset = 0.8621
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset hfog-MaxDist-Normal
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.239458
Aperture = 0
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 83.33
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,1.23076
CamLightMin = 0.44304
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0.4
ReflectionsNumber = 0
SpotLight = 1,0.694118,0.439216,1
LightPos = 1.0112,0.1124,8.6516
LightSize = 0.1134
LightGlowRad = 1.4189
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.305882,0.392157,0.564706
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Fallof = 0.04211
HF_Intensity = 2.29869
HF_Color = 0.768627,0.980392,1,0.49231
HF_Dir = -0.06024,0.06024,0.3012
HF_Offset = 0.8621
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset black-spots2
FOV = 0.58536
Eye = -0.0735562,-0.525815,0.26924
Target = -7.52087,6.14085,0.574743
FocalPlane = 0.604385
Aperture = 0
InFocusAWidth = 2.51
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 0.9
ToneMapping = 1
Exposure = 0.82653
Brightness = 0.8427
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -0.52129
FudgeFactor = 1
MaxRaySteps = 460
MaxDistance = 4.02
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.06122
SpecularExp = 205.88
SpecularMax = 100
CamLight = 1,1,1,1.53846
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Fog = 0
FogExp = 2
HardShadow = 0
ShadowSoft = 2
ShadowBlur = 0
Reflection = 0
ReflectionsNumber = 2
SpotLight = 1,0.694118,0.439216,1
LightPos = -1.0112,0.337,0.7418
LightSize = 0.45361
LightGlowRad = 0
LightGlowExp = 1.26665
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.0745098,0.0941176,0.133333
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
TextureScale = 0
EnableFloor = true
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.211765,0.388235,0.243137
HF_Fallof = 0.00001
HF_Intensity = 0
HF_Color = 0.768627,0.980392,1,0.38462
HF_Dir = -0.01204,-0.01204,1
HF_Offset = -0.0862
Up = 0.0590716,0.0202654,0.997771
HF_Scatter = 0.0
HF_Anisotropy = 0.0
HF_CastShadow = false
SpotGlow = true
#endpreset

#preset AO_ALONE
FOV = 0.4
Eye = -4.56185,2.29785,3.03203
Target = 3.07523,-2.13165,-1.6642
Up = 0.0795471,-0.148903,0.985647
FocalPlane = 1
Aperture = 0
InFocusAWidth = 0
ApertureNbrSides = 5 NotLocked
ApertureRot = 0
ApStarShaped = false NotLocked
Gamma = 2
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 1
Bloom = false
BloomIntensity = 0.25
BloomPow = 2
BloomTaps = 4
Detail = -3
DetailAO = -0.5
FudgeFactor = 1
MaxRaySteps = 128
MaxDistance = 80
Dither = 0.60204
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.4
SpecularExp = 8.929
CamLight = 1,1,1,1
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Reflection = 0
ReflectionsNumber = 0 Locked
SpotLight = 1,1,1,0
LightPos = 1.1688,3.2468,1.948
LightSize = 0.1
LightFallOff = 0
LightGlowRad = 0
LightGlowExp = 1
HardShadow = 1 Locked
ShadowSoft = 20
BaseColor = 1,1,1
OrbitStrength = 0
X = 0.105882,0.423529,0.835294,0.5534
Y = 1,0.752941,0.00784314,1
Z = 0.329412,0.831373,0.215686,-1
R = 0.945098,0.545098,0.494118,0.09804
BackgroundColor = 0,0,0
GradientBackground = 0.3
CycleColors = true
Cycles = 4.04901
EnableFloor = true
FloorNormal = 0,0,0.90244
FloorHeight = -0.6
FloorColor = 1,1,1
HF_Const = 0
HF_Scatter = 0.59829
HF_Anisotropy = 0
HF_Dir = 0,0,1
HF_Offset = 0
HF_Color = 1,1,1,1
TextureScale = 1
HF_Fallof = 1e-05
HF_Intensity = 0
HF_CastShadow = false
SpotGlow = false
#endpreset


#preset fog
FOV = 0.58536
Eye = -2.15447,-1.70138,0.774847
Target = 5.26105,4.92654,-0.264737
Up = -0.0837897,-0.070633,0.993977
FocalPlane = 1.45921
Aperture = 5e-05
InFocusAWidth = 0.9434
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 2.2
ToneMapping = 5
Exposure = 0.40245
Brightness = 1
Contrast = 1.4706
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -1.5
FudgeFactor = 1
MaxRaySteps = 260
MaxDistance = 63.83
Dither = 0.53608
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.51162
SpecularExp = 205.88
CamLight = 1,1,1,0
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Reflection = 0.21519
ReflectionsNumber = 0 Locked
SpotLight = 1,0.886275,0.541176,10
LightPos = -3.7662,1.4286,1.1688
LightSize = 0.08235
LightFallOff = 0.24658
LightGlowRad = 1.4189
LightGlowExp = 1.26665
HardShadow = 1 Locked
ShadowSoft = 0
BaseColor = 0.745098,0.639216,0.568627
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.305882,0.392157,0.564706
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Const = 0.1
HF_Dir = 0,0,1
HF_Offset = 0
HF_Color = 0.768627,0.980392,1,0
TextureScale = 0
HF_Intensity = 0
HF_Scatter = 1
HF_Fallof = 0.16635
HF_Anisotropy = 0.125
#endpreset


#preset fog-realistic-attempt
FOV = 0.58536
Eye = 1.30077,4.66456,1.30743
Target = -3.08461,-4.13768,-0.506102
Up = -0.0941989,-0.191827,0.976898
FocalPlane = 1.45921
Aperture = 5e-05
InFocusAWidth = 0.9434
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 2.2
ToneMapping = 2
Exposure = 3
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -1.5
FudgeFactor = 1
MaxRaySteps = 260
MaxDistance = 63.83
Dither = 0.53608
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.51162
SpecularExp = 205.88
CamLight = 1,1,1,0
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Reflection = 0.21519
ReflectionsNumber = 0 Locked
SpotLight = 1,0.886275,0.541176,10
LightPos = -2.987,-0.1298,0.909
LightSize = 0.08235
LightFallOff = 2
LightGlowRad = 1.4189
LightGlowExp = 1.26665
HardShadow = 1 Locked
ShadowSoft = 0
BaseColor = 0.745098,0.639216,0.568627
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0.305882,0.392157,0.564706
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Const = 0.25
HF_Dir = 0,0,1
HF_Offset = 0
HF_Color = 0.768627,0.980392,1,0.08
TextureScale = 0
HF_Intensity = 0
HF_Scatter = 0.17808
HF_Fallof = 0.16635
HF_Anisotropy = 0
#endpreset


#preset The_Mist
FOV = 0.58536
Eye = 1.37622,4.44583,0.141392
Target = -3.37024,-4.15432,2.01447
Up = 0.0226297,0.163818,0.986231
FocalPlane = 1.45921
Aperture = 5e-05
InFocusAWidth = 0.9434
ApertureNbrSides = 6 NotLocked
ApertureRot = 30
ApStarShaped = false NotLocked
Gamma = 2.2
ToneMapping = 2
Exposure = 3
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Bloom = false
BloomIntensity = 5
BloomPow = 1.2941
BloomTaps = 15
Detail = -3.6
DetailAO = -1.5
FudgeFactor = 1
MaxRaySteps = 260
MaxDistance = 760
Dither = 0.53608
NormalBackStep = 1
AO = 0,0,0,1
AoCorrect = 0
Specular = 0.51162
SpecularExp = 205.88
CamLight = 1,1,1,0
CamLightMin = 1
Glow = 1,1,1,0
GlowMax = 20
Reflection = 0.21519
ReflectionsNumber = 0 Locked
SpotLight = 1,0.886275,0.541176,10
LightPos = -3.8842,-0.909,2.2314
LightSize = 0.08235
LightFallOff = 2
LightGlowRad = 1.4189
LightGlowExp = 1.26665
HardShadow = 1 Locked
ShadowSoft = 0
BaseColor = 0.745098,0.639216,0.568627
OrbitStrength = 0
X = 0.5,0.6,0.6,0.2126
Y = 1,0.6,0,0.30708
Z = 0.8,0.78,1,0.35434
R = 0.666667,0.666667,0.498039,0.03174
BackgroundColor = 0,0,0
GradientBackground = 0.2381
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,0.17074
FloorHeight = 0
FloorColor = 0.403922,0.729412,0.45098
HF_Const = 0
HF_Scatter = 0.59829
HF_Anisotropy = 0.84
HF_Dir = 0,0,1
HF_Offset = 0
HF_Color = 0.384314,0.772549,0.890196,0
TextureScale = 0
HF_Fallof = 1.51194
HF_Intensity = 0.05505
HF_CastShadow = true
SpotGlow = false
#endpreset
